(function(){
  var consolelog = function(l) {
    if(typeof console == 'object' && typeof console.log == 'function')
      console.log(l);
  }
  if (typeof window.XWiki == "undefined") {    // global XWiki namespace
     window.XWiki = {};
  }
  var XWiki = window.XWiki;
  if(typeof XWiki != 'undefined' && typeof XWiki.Tooltip == 'undefined') {
    XWiki.Tooltip = Class.create();
    XWiki.Tooltip.prototype = {
      initialize: function(activator, tooltip, options) {
        this.activator = activator;           
        //consolelog(tooltip);
        this.initialized = false;
        this.options = { mouseFollow: false,
                         delay: 250,
                         duration: .25,
                         'class': 'help-tooltip' }
        Object.extend(this.options, options || {});
        this.tooltip = new Element('div', {'class': this.options['class']}).update(tooltip);

        // Event handlers
        Event.observe(this.activator, 'mouseover', this.mouseoverTarget.bindAsEventListener(this));
        Event.observe(this.activator, 'mouseout', this.mouseoutTarget.bindAsEventListener(this));
        Event.observe(this.tooltip, 'mouseover', this.mouseoverTooltip.bindAsEventListener(this));
        Event.observe(this.tooltip, 'mouseout', this.mouseoutTooltip.bindAsEventListener(this));
      },
      
      mouseoverTarget: function(e) {
        //consolelog('mouseoverTarget');
        this.pointerX = Event.pointerX(e);
        this.pointerY = Event.pointerY(e);
        if(!this.initialized) {
          //consolelog('mouseoverTarget:!this.initialized');
          this.timeout = window.setTimeout(this.appear.bind(this), this.options.delay);
        }
      },

      mouseoutTarget: function(e) {
        //consolelog('mouseoutTarget');
        if(this.appearfx) {
          this.appearfx.cancel();
          delete this.appearfx;
        }        
        this.fadefx = new Effect.Fade(this.tooltip, {duration: this.options.duration});
        this._clearTimeout(this.timeout);
        this.initialized = false;
      },

      mouseoverTooltip: function(e) {
        //consolelog('mouseoverTooltip');
        if(this.fadefx) {
          this.fadefx.cancel();
          delete this.fadefx;
        }
        this.appearfx = new Effect.Appear(this.tooltip, 'appear', {duration: this.options.duration});
      },

      mouseoutTooltip: function(e) {
        //consolelog('mouseoutTooltip');
        if(this.appearfx) {
          this.appearfx.cancel();
          delete this.appearfx;
        }
        this.fadefx = new Effect.Fade(this.tooltip, {duration: this.options.duration});
      },

      mousemoveTarget: function(e) {
        //consolelog('mousemoveTarget');
        this.pointerX = Event.pointerX(e);
        this.pointerY = Event.pointerY(e);
      },
  
      appear: function() {
        //consolelog('appear');
        if(!this.initialized) {          
          //this.activator.ancestors()[0].insert({'bottom':this.tooltip});
          // hack to place the tooltip on top
          Element.insert($('globallinks'), {'bottom': this.tooltip});
        } else {
          Element.removeClassName(this.tooltip, 'tooltip-topleft');
          Element.removeClassName(this.tooltip, 'tooltip-topright');
          Element.removeClassName(this.tooltip, 'tooltip-bottomleft');
          Element.removeClassName(this.tooltip, 'tooltip-bottomright');
        }

        Event.observe(this.activator, 'mousemove', this.mousemoveTarget.bindAsEventListener);
        if(!this.mouseFollow)
          Event.stopObserving(this.activator, 'mousemove');

        this.tooltip.style.position = 'absolute';
        var width = Element.getWidth(this.tooltip);
        //consolelog('width:'+width);
        var height = Element.getHeight(this.tooltip);
        //consolelog('height:'+height);
        var top = this.pointerY;
        //consolelog("Y:"+this.pointerY);
        var left = this.pointerX;
        //consolelog("X:"+this.pointerX);
        // tooltip width doesn't fit the window
        if(left + width >= Element.getWidth(document.body)) {
          if(this.pointerX <= width)
            left = 0;
          else
            left = this.pointerX - width;
          //consolelog('width doesnt fit:'+left);
          // tooltip height doesn't fit the window
          if(top + height >= Element.getHeight(document.body)) {
            if(this.pointerY <= height)
              top = 0;
            else
              top = this.pointerY - height;
            //consolelog('height doesnt fit'+top);
            Element.addClassName(this.tooltip, 'tooltip-bottomright');
          }
          else {
            Element.addClassName(this.tooltip, 'tooltip-topright');
          }          
        }
        else {
          //left = left + 7;
          //consolelog('width fits'+left);
          // tooltip height doesn't fit the window
          if(top + height >= Element.getHeight(document.body)) {
            if(this.pointerY <= height)
              top = 0;
            else
              top = top - height;
            //consolelog('height doesnt fit'+top);
            Element.addClassName(this.tooltip, 'tooltip-bottomleft');
          }
          else {
            Element.addClassName(this.tooltip, 'tooltip-topleft');
          }          
        }        

        // TODO check for top and bottom to switch to bottomleft or bottomright classes
        this.tooltip.style.top = top + 'px';
        this.tooltip.style.left = left + 'px';
        this.initialized = true;
        this.appearfx = Effect.Appear(this.tooltip, {duration: this.options.duration});
      },

      _clearTimeout: function(t) {
        //consolelog('_cleartimeout');
        clearTimeout(t);
        clearInterval(t);
        return null;
      }
    };
  };

})();

// TODO  fix mouseoverTooltip, mouseoutTooltip from firing to many times

  var XWiki = window.XWiki;
  if(typeof XWiki != 'undefined' && typeof XWiki.Dropdown == 'undefined') {
    XWiki.Dropdown = Class.create();
    XWiki.Dropdown.prototype = {
      initialize: function(activator, dropdown, options)  {
        this.activator = activator;
        this.dropdown = dropdown;
        this.initialized = false;
        this.options = { delay: 250,
                         duration: 0.25, }
        Object.extend(this.options, options || {});
        Event.observe(this.activator, 'mouseover', this.mouseoverActivator.bindAsEventListener(this));
        Event.observe(this.activator, 'mouseout', this.mouseoutActivator.bindAsEventListener(this));
        Event.observe(this.dropdown, 'mouseover', this.mouseoverDropdown.bindAsEventListener(this));
        Event.observe(this.dropdown, 'mouseout', this.mouseoutDropdown.bindAsEventListener(this));
      },
      
      mouseoverActivator: function(e) {
        if(!this.initialized) {
          this.timeout = window.setTimeout(this.appear.bind(this), this.options.delay);
        }
      },

      mouseoutActivator: function(e) {
        if(this.appearfx) {
          this.appearfx.cancel();
          delete this.appearfx;
        }        
        this.fadefx = new Effect.Fade(this.dropdown, {duration: this.options.duration});
        this._clearTimeout(this.timeout);
        this.initialized = false;
      },

      mouseoverDropdown: function(e) {
        if(this.fadefx) {
          this.fadefx.cancel();
          delete this.fadefx;
        }
        this.appearfx = new Effect.Appear(this.dropdown, 'appear', {duration: this.options.duration});
      },

      mouseoutDropdown: function(e) {
        if(this.appearfx) {
          this.appearfx.cancel();
          delete this.appearfx;
        }
        this.fadefx = new Effect.Fade(this.dropdown, {duration: this.options.duration});
      },

      appear: function() {
        this.initialized = true;
        this.appearFX = Effect.Appear(this.dropdown, {duration: this.options.duration});
        var container = Element.ancestors(this.activator)[0];
        var ccoords = Element.viewportOffset(container);
        var acoords = Element.viewportOffset(this.activator);
        var ddwidth = Element.getWidth(this.dropdown);
        if(ddwidth < acoords.left - ccoords.left) {
          this.dropdown.style.width = (acoords.left - ccoords.left) + 'px';
        }
      },
      _clearTimeout: function(t) {
        //consolelog('_cleartimeout');
        clearTimeout(t);
        clearInterval(t);
        return null;
      }
    };
  };

